EDIT - bug #8426

IndexOutOfBoundsException during serialization of RegistrationWorkingSet
07/30/2019 05:09 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.9

Severity: normal Found in Version:

Description

IndexOutOfBoundsException during serialization of RegistrationWorkingSet:

[flora-central-africa] 2019-07-30 15:34:41,493 INFO [gtp532445947-4972] [eu.etaxonomy.cdm.remote.c
ontroller.BaseController] - doGetMethod() [doGetAnnotations] GET: /flora-central-africa/reference/c
2585e9d-blcl-4bbl-b40b-£f53aebbc89c4d/annotations
[flora-central-africa] 2019-07-30 15:34:41,516 INFO [gtp532445947-4977] [eu.etaxonomy.cdm.remote.c
ontroller.RegistrationDTOController] - doGetRegistrationWorkingSet () GET: /flora-central-africa/re
gistrationWorkingSetDTO/c2585e9d-blcl-4bbl-b40b-£f53ae6bc89c4
2019-07-30 15:34:41,540 WARN [gtp532445947-4977] [org.eclipse.jetty.servlet.ServletHandler] -
org.springframework.web.util.NestedServletException: Request processing failed; nested exception i
s net.sf.json.JSONException: java.lang.reflect.InvocationTargetException

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet.java:9
81)

at org.springframework.web.servlet.FrameworkServlet.doGet (FrameworkServlet. java:860)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:687)

Caused by: net.sf.json.JSONException: java.lang.reflect.InvocationTargetException

at net.sf.json.JSONObject.defaultBeanProcessing (JSONObject. java:818)

at net.sf.json.JSONObject._fromBean (JSONObject. java:699)

at net.sf.json.JSONObject.fromObject (JSONObject. java:172)

at eu.etaxonomy.cdm.remote.view.JsonView.render (JsonView. java:128)

at eu.etaxonomy.cdm.remote.view.JsonView.render (JsonView. java:188)

at org.springframework.web.servlet.DispatcherServlet.render (DispatcherServlet. java:1243)

at org.springframework.web.servlet.DispatcherServlet.processDispatchResult (DispatcherServl
et.java:1027)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet. java:971

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:893)
at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:9
69)
5 61 more
Caused by: java.lang.reflect.InvocationTargetException
at sun.reflect.GeneratedMethodAccessor59692.invoke (Unknown Source)
at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
at java.lang.reflect.Method.invoke (Method. java:498)
at org.apache.commons.beanutils.PropertyUtilsBean.invokeMethod (PropertyUtilsBean.java:2116

at org.apache.commons.beanutils.PropertyUtilsBean.getSimpleProperty (PropertyUtilsBean. java
:1267)

at org.apache.commons.beanutils.PropertyUtilsBean.getNestedProperty (PropertyUtilsBean. java
:808)

at org.apache.commons.beanutils.PropertyUtilsBean.getProperty (PropertyUtilsBean. java:884)

at org.apache.commons.beanutils.PropertyUtils.getProperty (PropertyUtils. java:464)

at net.sf.json.JSONObject.defaultBeanProcessing (JSONObject. java:749)

... 70 more
Caused by: java.lang.IndexOutOfBoundsException: Index: 0, Size: 0

at java.util.ArrayList.rangeCheck (ArrayList.java:657)

at java.util.ArrayList.get (ArrayList.java:433)

at eu.etaxonomy.cdm.api.service.dto.RegistrationWorkingSet.getRegistrationDate (Registratio
nWorkingSet. java:202)
79 more

Associated revisions

Revision 6b0f8cdf - 07/30/2019 09:37 PM - Andreas Miiller
fix #8426 fix IOOB Exception in RegistrationWorkingSet serialization

History

#1 - 07/30/2019 09:40 PM - Andreas Miiller
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|6b0f8cdfe1643a96638e02dbd924ffd0007785f8.

#2 - 07/30/2019 09:43 PM - Andreas Miiller

- Target version changed from Release 5.10 to Release 5.9

isn't this very easy to fix? Therefore | put it to 5.9 (and also tried to fix in the meanwhile).

Open question: do we also need to fix getRegistrationDTO(uuid) in line 185:

return registrationDTOs.stream().filter(r —-> r.getUuid() .equals (registrationUuid) ).findFirst();
| have no experience how findFirst reacts if filter returns an empty stream. Can you have a look.

#3 - 07/31/2019 02:32 PM - Andreas Kohlbecker

- Status changed from Resolved to Closed

- Assignee changed from Andreas Kohlbecker to Andreas Miiller

- % Done changed from 50 to 100

findFirst() will returns an Optional describing the first element of this stream, or an empty Optional if the stream is empty.
So this works as expected.

Your fix for the IOOB Exception looks perfect.
